"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MDXContent;

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@mdx-js/react");

var _ui = require("@teambit/ui.mdx-scope-context");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var layoutProps = {};
var MDXLayout = "wrapper";

function MDXContent(_ref) {
  var components = _ref.components,
      props = _objectWithoutProperties(_ref, ["components"]);

  return (0, _react2.mdx)(MDXLayout, _extends({}, layoutProps, props, {
    components: components,
    mdxType: "MDXLayout"
  }), (0, _react2.mdx)(_ui.MDXScopeProvider, {
    components: {},
    mdxType: "MDXScopeProvider"
  }, (0, _react2.mdx)("p", null, "Bit components can be thought of as a super-set of standard packaged node modules.\nEach component contains a consumable package in addition to its documentation, history and other information that enables it to be independently developed and maintained."), (0, _react2.mdx)("p", null, "The PKG aspect handles the configuration, publishing and packing of component packages.\nIt adds its own build task to the build pipeline, to create component packages and include them in as part of the component artifacts.\nThis automation includes generating the package name and other properties according to the component's details."), (0, _react2.mdx)("h4", null, "Features"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("strong", {
    parentName: "li"
  }, "Efficient ", (0, _react2.mdx)("inlineCode", {
    parentName: "strong"
  }, "package.json"), " configuration:"), " Use the PKG's workspace config API to add or override ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "package.json"), " properties to a group of components, all at once.\nUse PKG's 'placeholders' to integrate component-specific data into the component's package configurations."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("strong", {
    parentName: "li"
  }, "An API for programmable ", (0, _react2.mdx)("inlineCode", {
    parentName: "strong"
  }, "package.json"), " configuration:"), " Use PKG's API to provide your extensions with \"packaging capabilities\". Modify the ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "package.json"), " to suit your extension's needs, whether it is an environment or any other type of extension."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("strong", {
    parentName: "li"
  }, "Automated packing and publishing:"), " - PKG is registered to your build pipeline. That means every 'build' will also test 'packing' and every tagging of a new release version will also include 'publishing'. Your components and packages versions are alway in-sync."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("strong", {
    parentName: "li"
  }, "\"On-demand\" packing and publishing:"), " - PKG offers the ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "pack"), " and ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "preview"), " CLI commands for a manual and on-demand usage.")), (0, _react2.mdx)("h3", null, "Quickstart & configuration"), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "This aspect is only configurable using the 'variants' workspace API.")), (0, _react2.mdx)("h4", null, "Package properties"), (0, _react2.mdx)("p", null, "Use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "packageJson"), " property to add or override the default ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "package.json"), " for your component packages."), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "Warning! Packages with a modified ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "name"), " property will not be published to Bit.dev's registry.")), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-js"
  }, "{\n  \"ui/*\": {\n    \"teambit.pkg/pkg\": {\n      \"packageJson\": {\n          \"name\": \"@{scope}/{name}\",\n          \"private\": false,\n          \"main\": \"dist/{main}.js\",\n          \"custom-prop\": \"value\"\n      }\n    }\n  }\n}\n")), (0, _react2.mdx)("h4", null, "Publish"), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "If ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "publishConfig"), " or ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "name"), " are not set, packages will be published to Bit.dev's registry.")), (0, _react2.mdx)("h5", null, "npm arguments"), (0, _react2.mdx)("p", null, "You can specify additional arguments to the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "npm publish"), " command by adding an array of args to ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "packageManagerPublishArgs"), "."), (0, _react2.mdx)("p", null, "For example:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-js"
  }, "\"ui/*\": {\n  \"teambit.pkg/pkg\": {\n    \"packageManagerPublishArgs\": [\"--access public\"]\n  }\n}\n")), (0, _react2.mdx)("h4", null, "npmjs Registry"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, "Use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "name"), " property to set the publishing process to your ", (0, _react2.mdx)("a", {
    parentName: "li",
    "href": "https://docs.npmjs.com/cli/v6/using-npm/scope"
  }, "npm scope"), "."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, "Use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "private"), " ", (0, _react2.mdx)("em", {
    parentName: "li"
  }, "(boolean)"), " property to set packages to be published with either private or public access.")), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-js"
  }, "{\n  \"ui/*\": {\n    \"teambit.pkg/pkg\": {\n      \"packageJson\": {\n          \"name\": \"@{scope}/{name}\",\n          \"private\": false,\n      }\n    }\n  }\n}\n")), (0, _react2.mdx)("h4", null, "Private registry"), (0, _react2.mdx)("p", null, "Use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "scope"), " and ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "registry"), " properties to configure the publishing process to your own private registry (and scope)."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-js"
  }, "\"ui/*\": {\n  \"teambit.pkg/pkg\": {\n    \"packageJson\": {\n       \"publishConfig\": {\n         \"scope\": \"@custom\",\n         \"registry\": \"http://localhost:4873\"\n      }\n    }\n  }\n}\n")), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "Packages with a modified ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "publishConfig"), " property will not be published to Bit.dev's registry.")), (0, _react2.mdx)("h4", null, "Placeholders"), (0, _react2.mdx)("p", null, "Placeholders are an easy way to inject component-specific information into the 'pkg' configurations."), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "{name}"), " - The name of the component."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "{scope}"), " - The name of the component scope."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "{main}"), " - the name of the main file (leaving out the extension) - for example ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "index.js"), " will be ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "index"), ".")), (0, _react2.mdx)("p", null, "For example:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-js"
  }, " \"packageJson\": {\n    \"main\": \"dist/{main}.js\"\n  }\n")), (0, _react2.mdx)("h3", null, "CLI Reference"), (0, _react2.mdx)("h4", null, "Pack"), (0, _react2.mdx)("p", null, "Creates a TAR file (to be published to a node package registry):"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-shell"
  }, "bit pack <component-id>\n")), (0, _react2.mdx)("p", null, "Overrides the existing TAR file (in the same location):"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-shell"
  }, "bit pack <component-id> --override\n\nbit pack <component-id> -o\n")), (0, _react2.mdx)("p", null, "Returns the output in a JSON format:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-shell"
  }, "bit pack <component-id> --json\n\nbit pack <component-id> -j\n")), (0, _react2.mdx)("h4", null, "Publish"), (0, _react2.mdx)("p", null, "Publishes an exported component:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-shell"
  }, "bit publish <componentId>\n")), (0, _react2.mdx)("p", null, "Publishes a staged component that has not yet been exported:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-shell"
  }, "bit publish <component-id> --allow-staged\n")), (0, _react2.mdx)("p", null, "Checks if the publishing process will be done successfully (without publishing):"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-shell"
  }, "bit publish <component-id> --dry-run\n\nbit publish <component-id> -d\n")), (0, _react2.mdx)("p", null, "Returns the output as JSON:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-shell"
  }, "bit publish <component-id> --json\n\nbit publish <component-id> --j\n"))));
}

;
MDXContent.isMDXComponent = true;

//# sourceMappingURL=pkg.mdx.js.map